#define BLOCK_DIM 8
#define SIZE2 64

#include <stdio.h>
#include <orthonormalize_kernel.cu>

int main() {
	float a[SIZE2] = 
	{12, 54, 87, 54, 87, 5, 9, 78,
	4,  5,  66, 97, 88, 5, 8, 99,
	21, 45, 78, 45, 78, 8, 8, 87,
	0,  8,  33, 79, 44, 0, 0, 11,
	3,  70, 86, 20, 76, 0, 1, 13,
	33, 44, 77, 22, 22, 2, 2, 22,
	88, 88, 88, 88, 77, 7, 7, 66,
	12, 12, 14, 98, 55, 7, 8, 18};

	float *a_d;
	cudaMalloc((void**)&a_d, SIZE2 * sizeof(float));
	cudaMemcpy(a_d, a, SIZE2 * sizeof(float), cudaMemcpyHostToDevice);
	orthonormalize<<<BLOCK_DIM, BLOCK_DIM>>>(a_d);
	cudaMemcpy(a, a_d, SIZE2 * sizeof(float), cudaMemcpyDeviceToHost);
	for (int i = 0; i < SIZE2; i++) {
		if (i % BLOCK_DIM == 0) printf("\n");
		printf("%2.3f\t ", a[i]);
	}
	printf("\n");
	
	cudaFree(a_d);
	
	return 0;
}
